//+------------------------------------------------------------------+
//|                       Renko auto-trading EA by Steve Hopwood.mq4 |
//|                                  Copyright  2010, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  hold "Hold"
#define  golong "Go long"
#define  goshort "Go short"
/*

bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take, int magic)
void DisplayUserFeedback()
void ReadIndi()

*/

extern double  Lot = 0.01;
extern int     StopLoss = 50;
extern int     TakeProfit = 50;
extern int     MagicNumber = 2974634;
extern string  TradeComment="Louise";
extern bool    CriminalIsECN=false;
extern string  mmis="----Murray Advisor inputs----";
extern int     P = 64;
extern int     StepBack = 0;
extern color   No_Trade = Salmon;
extern color   Ok_Trade = LightCyan;
extern string  mis="----Odds and ends----";
extern int     DisplayGapSize=30;


//Trade types etc
bool           LongExists, ShortExists;
int            TicketNo;
string         TradingStatus;

//Misc
int            slippage;
string         Gap, ScreenMessage;


void DisplayUserFeedback()
{
   if (IsTesting() && !IsVisualMode() ) return;

   ScreenMessage = "";
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "YOU TRADE THIS ROBOT AT YOUR OWN RISK. YOU COULD EASILY LOSE A LOT OF MONEY BY DOING SO.", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading status: ", TradingStatus, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Lot size: ", Lot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Take profit: ", TakeProfit, " pips",  NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Stop loss: ", StopLoss, " pips",  NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number: ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trade comment: ", TradeComment, NL);
   if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = true", NL);
      
   
   
   Comment(ScreenMessage);
   
}//void DisplayUserFeedback()

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
   //Accommodate different quote sizes
   double multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   slippage*= multiplier;
   StopLoss*= multiplier;
   TakeProfit*= multiplier;


   if (TradeComment == "") TradeComment = " ";

   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }//if (DisplayGapSize >0)
   
   Comment(".......................Waiting for the first tick");
   //start();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
//----
   return(0);
}


bool DoesTradeExist()
{
   
   TicketNo = 0;
   LongExists = false;
   ShortExists = false;
   
   if (OrdersTotal() == 0) 
   {
      return(false);
   }//if (OrdersTotal() == 0) 
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      
      //if ( OrderMagicNumber() == SendMagicNumber && OrderSymbol() == Symbol() )      
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         TicketNo = OrderTicket();
         if (OrderType() == OP_BUY) LongExists = true;
         if (OrderType() == OP_SELL) ShortExists = true;
         return(true);         
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

   return(false);

}//End bool DoesTradeExist()

bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take, int magic)
{
   
   //if (StopTrading) return(true);
   /*
   if (!IsTesting())
   {   
      if (!IsTradeAllowed() ) return(false);
      if (!IsConnected() ) return(false);
      if (!IsExpertEnabled() ) return(false);
      if (!IsTradeContextBusy() ) return(false);
   }//if (!IsTesting)
   */
   
   
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYSTOP) col = Green;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);
   
   
   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, magic, expiry, col);
   
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, magic, expiry, col);
      if (ticket > -1)
      {
         if (stop >0 && take > 0) bool result = OrderModify(OrderTicket(), OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE);
         //Stop loss but no take profit
         if (stop >0 && take == 0) result = OrderModify(OrderTicket(), OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
         //Take profit but no stop loss
         if (stop ==0 && take > 0) result = OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE);
         if (!result)
         {
             int err=GetLastError();
             Print(Symbol(), " ", type," SL or TP order modify failed with error(",err,"): ",ErrorDescription(err));
         }//if (!result)			  
      }//if (ticket > -1)
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
      if (type == OP_SELL) stype = "OP_SELL";
      if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
      err=GetLastError();
      Alert(Symbol(), " ", stype," Louise order send failed with error(",err,"): ",ErrorDescription(err));
      Print(Symbol(), " ", stype," Louise order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)  
   
   
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

void ReadIndi()
{

/*
extern int P = 64;
extern int StepBack = 0;

extern bool SoundAlert = true;
extern bool DrawBox = true;
extern bool PipDif = true;
extern bool MidLines = false;

extern color No_Trade = Salmon;
extern color Ok_Trade = LightCyan;
*/


   TradingStatus = hold;
   int val = iCustom(Symbol(), 0, "Murrey Advisor V2.3", P, StepBack, false, false, true, false, No_Trade, Ok_Trade, 0, 0);
   
   if (val == 1) TradingStatus = golong;
   if (val == 2) TradingStatus = goshort;
   
   
}//void ReadIndi()

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   

   
   ReadIndi();
   DisplayUserFeedback();
   if (TradingStatus == hold)
   {
      return;
   }//if (TradingStatus == hold)
   
   bool result;
   
   DisplayUserFeedback();
   
   DoesTradeExist();
   double take, stop;
   
   RefreshRates();
   //Has there been a long signal?
   if (TradingStatus == golong && !LongExists)
   {
      if (ShortExists)
      {
         result = OrderClose(TicketNo, OrderLots(), OrderClosePrice(), 100000, Blue);
         if (!result) return;
      }//if (ShortExists)
      if (LongExists) return;
      if (TakeProfit > 0) take = NormalizeDouble(Ask + (TakeProfit * Point), Digits);
      if (StopLoss > 0) stop = NormalizeDouble(Ask - (StopLoss * Point), Digits);
      result = SendSingleTrade(OP_BUY, TradeComment, Lot, Ask, stop, take, MagicNumber);
      
   }//if (TradingStatus == golong && !LongExists)
   
   //Has there been a short signal?
   if (TradingStatus == goshort && !ShortExists)
   {      
      if (LongExists)
      {
         result = OrderClose(TicketNo, OrderLots(), OrderClosePrice(), 100000, Blue);
         if (!result) return;
      }//if (LongExists)
      if (ShortExists) return;
      if (TakeProfit > 0) take = NormalizeDouble(Bid - (TakeProfit * Point), Digits);
      if (StopLoss > 0) stop = NormalizeDouble(Bid + (StopLoss * Point), Digits);
      result = SendSingleTrade(OP_SELL, TradeComment, Lot, Bid, stop, take, MagicNumber);      
   }//if (TradingStatus == goshort && !ShortExists)
   
      
   

   
//----
   return(0);
}
//+------------------------------------------------------------------+